clear;   % Table 9
load TFuturesReturn;
load TSPReturn;
load dates;
load Tbasis;
load TSpecNetLongChange;
load THedgeNetLongChange;
load TNonNetLongChange;
load TSpecNetLong;
load THedgeNetLong;
load TNonNetLong;
load TVIX;
load TOI;
load Ivol;

% Ivol for individual commodities are simulated data.



roll=52;

ss=26; 

for i=roll+1:size(TFuturesReturn,1)
    
    for bcount=1:ss
        ret=ols(TFuturesReturn(i-roll+1:i,bcount),[ones(roll,1) TSPReturn(i-roll+1:i)]);
        beta(i,bcount)=ret.beta(2);
        rstd(i,bcount)=std(ret.resid)*sqrt(52);
    end

end


for i=roll:size(TFuturesReturn,1)
 for bcount=1:ss
    smoothHedge(i,bcount)=-mean(THedgeNetLong(i-roll+1:i,bcount))/TOI(i,bcount);
 end
end

istep=0;

tFuturesReturn=[];
tbasis=[];
tSpecNetLongChange=[];
tHedgeNetLongChange=[];
tNonNetLongChange=[];
tSpecNetLong=[];
tHedgeNetLong=[];
tNonNetLong=[];
tPressure=[];
tSmooth=[];
dummy=[];
newvar=[];
newvar2=[];
Spec=zeros(size(TSpecNetLongChange(roll+1:end-1,1)));
s2=size(TFuturesReturn(roll+2:end,1),1);
dummy=zeros(s2*22,22);
dummyVIX=[];
LReturn=[];
tIvol=[];
   indexdummy=1;
for index=1:ss
    
    aa=find(isnan(Ivol(:,index)));
    if ~isempty(aa)
        continue;
    end
    tFuturesReturn=[tFuturesReturn;TFuturesReturn(roll+2:end,index)];
    tbasis=[tbasis;Tbasis(roll+1-istep:end-1-istep,index)];
    tSpecNetLongChange=[tSpecNetLongChange;TSpecNetLongChange(roll+1-istep:end-1-istep,index)];
    tHedgeNetLongChange=[tHedgeNetLongChange; THedgeNetLongChange(roll+1-istep:end-1-istep,index)];
 
    cc= find(TSpecNetLong(roll+1-istep:end-1-istep,index)>=0);
    dd= find(TSpecNetLong(roll+1-istep:end-1-istep,index)<0);
    Spec(cc)=1; Spec(dd)=-1;
    tPressure=[tPressure;Spec.*rstd(roll+1-istep:end-1-istep,index)];
    tSmooth=[tSmooth;smoothHedge(roll+1-istep:end-1-istep,index)];
    
    dummy(s2*(indexdummy-1)+1:s2*indexdummy,indexdummy)=1;
    indexdummy=indexdummy+1;
    
    
   
      dd=zeros(size(Ivol(roll+1-istep:end-1-istep,index)));
       [h I]=sort(Ivol(roll+1-istep:end-1-istep,index));
       dd(I(floor(size(dd,1)/2*1):end))=1;
    tIvol=[tIvol;dd];  % dummy for individual commodity Ivol
    
     ddVIX=zeros(size(TVIX(roll+1-istep:end-1-istep,1))); 
     [h I]=sort(TVIX(roll+1-istep:end-1-istep,1));
     ddVIX(I(floor(size(dd,1)/2*1):end))=1; % dummy for vix
     
     dummyVIX=[dummyVIX;ddVIX];
     
    LReturn=[LReturn;TFuturesReturn(roll+1-istep:end-1-istep,index)];
end
    
br=tFuturesReturn;



reg=[ tHedgeNetLongChange  tHedgeNetLongChange.*tIvol tSmooth tbasis tPressure LReturn dummy];  
%reg=[ tHedgeNetLongChange  tHedgeNetLongChange.*dummyVIX tSmooth tbasis tPressure LReturn dummy];  
%reg=[ tHedgeNetLongChange  tHedgeNetLongChange.*dummyVIX tHedgeNetLongChange.*tIvol tSmooth tbasis tPressure LReturn dummy];  

ret=nwest(br,reg,4);

time=dates(roll+1-istep:end-1-istep);
Ttime=repmat(time,ss,1);
commodity=ones(size(TFuturesReturn(roll+2:end,1)))*[1:22];
Commodity=reshape(commodity,size(TFuturesReturn(roll+2:end,1),1)*22,1);

ret2 = nwestpanel(br, reg,4, Commodity,Ttime, 0);

out=[ret.beta(1)*100;ret2(1,3);ret.beta(2)*100;ret2(2,3);ret.beta(3)*100;ret2(3,3);ret.beta(4)*100;ret2(4,3);ret.rsqr];
